function parseTeachers(list) {
    var state = 'inb4dep',
        department = { name: '', people: [] },
        data = [];

    list.forEach(function (line) {
        var token = line.trim();

        switch (state) {
            case 'inb4dep':
                if (!token.length)
                    break;
                state = 'dep';

            case 'dep':
                token.length
                    ? department = { name: token, people: [] }
                    : state = 'inb4names';
                break;

            case 'inb4names':
                if (!token.length)
                    break;
                state = 'names';

            case 'names':
                token.length
                    ? department.people.push(token)
                    : (data.push(department), state = 'inb4dep');
                break;
        }
    });

    if (state === 'names') {
        data.push(department);
    }

    return data;
}
